package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import java.sql.Timestamp;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENECURRENCYRATE*/
@Entity(name="TgeneCurrencyRate")
@Table(name="TGENECURRENCYRATE")
public class TgeneCurrencyRate extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneCurrencyRate
*/
@EmbeddedId
private TgeneCurrencyRateKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Manejo de optimistic locking del registro
*/
private Integer recordversion;

@Column(name="BUYRATE", nullable=true)

/**
* Cotizacion de compra asociada a la moneda
*/
private BigDecimal buyrate;

@Column(name="SELLRATE", nullable=true)

/**
* Cotizacion de venta asociada a la moneda
*/
private BigDecimal sellrate;

@Column(name="DATEFROM", nullable=true)

/**
* Fecha desde la cual estan viegnetes las cotizaciones de las monedas.
*/
private Timestamp datefrom;

/**Contructor por defecto*/
public TgeneCurrencyRate(){
}
/**Contructor de TgeneCurrencyRate
@param pPk Clave Primaria del entity
*/
public TgeneCurrencyRate(TgeneCurrencyRateKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneCurrencyRate
*/
public static TgeneCurrencyRate find(EntityManager pEntityManager,TgeneCurrencyRateKey pKey) throws Exception{
    TgeneCurrencyRate obj = pEntityManager.find(TgeneCurrencyRate.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneCurrencyRate
@return El objeto que referencia a la Clave primaria de TgeneCurrencyRate
*/
public TgeneCurrencyRateKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneCurrencyRate
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneCurrencyRate
*/
public void setPk(TgeneCurrencyRateKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de buyrate
@return valor de buyrate*/
public BigDecimal getBuyrate(){
  return buyrate;
}
/**Fija el valor de buyrate
@param pBuyrate nuevo Valor de buyrate*/
public void setBuyrate(BigDecimal pBuyrate){
  buyrate=pBuyrate;
}

/**Obtiene el valor de sellrate
@return valor de sellrate*/
public BigDecimal getSellrate(){
  return sellrate;
}
/**Fija el valor de sellrate
@param pSellrate nuevo Valor de sellrate*/
public void setSellrate(BigDecimal pSellrate){
  sellrate=pSellrate;
}

/**Obtiene el valor de datefrom
@return valor de datefrom*/
public Timestamp getDatefrom(){
  return datefrom;
}
/**Fija el valor de datefrom
@param pDatefrom nuevo Valor de datefrom*/
public void setDatefrom(Timestamp pDatefrom){
  datefrom=pDatefrom;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneCurrencyRate))return false;
    TgeneCurrencyRate that = (TgeneCurrencyRate) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneCurrencyRate
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneCurrencyRate
*/
public Object createInstance(){
 TgeneCurrencyRate instance=new TgeneCurrencyRate();	
 instance.setPk(new TgeneCurrencyRateKey());
 return instance;
}
/**Clona la entidad TgeneCurrencyRate
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneCurrencyRate p=(TgeneCurrencyRate)this.clone();
  p.setPk((TgeneCurrencyRateKey)this.pk.cloneMe());
  return p;
}
public Object getId() {
  return this.pk;
}
}
